import 'package:airpay_emar_package/airpay_package.dart';
import 'package:airpay_emar_package/model/CardDetailResponse.dart';
import 'package:airpay_emar_package/model/QrDecryptResponse.dart';
import 'package:airpay_emar_package/screens/airpay_UAE.dart';
import 'package:airpay_emar_package/screens/cardDetails.dart';
import 'package:airpay_emar_package/screens/QRDecrypt.dart';
import 'package:awesome_dialog/awesome_dialog.dart';
import 'package:email_validator/email_validator.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter/material.dart';
import 'package:flutter_barcode_scanner/flutter_barcode_scanner.dart';


class Home extends StatefulWidget {
  final bool isSandbox;
  Home({required this.isSandbox});

  @override
  _HomeState createState() => _HomeState(isSandbox: isSandbox);
}

class _HomeState extends State<Home> {
  final bool isSandbox;
  _HomeState({required this.isSandbox});

  var merchantId ="";
  var order_id ="";
  var amount_value="";
  var table_id ="";

  bool isSuccess = false;
  bool isVisible = false;
  TextEditingController fname = TextEditingController();
  TextEditingController lname = TextEditingController();
  TextEditingController email = TextEditingController();
  TextEditingController phone = TextEditingController();
  TextEditingController city = TextEditingController();
  TextEditingController state = TextEditingController();
  TextEditingController country = TextEditingController();
  TextEditingController pincode = TextEditingController();
  TextEditingController orderId = TextEditingController();
  TextEditingController amount = TextEditingController();
  TextEditingController fullAddress = TextEditingController();
  TextEditingController customvar = TextEditingController();

  void _showAddress() {
    setState(() {
      isVisible = !isVisible;
    });
  }

  @override
  void initState() {
    super.initState();

    fname.text = "test";
    lname.text = "test";
    email.text = "test@gmail.com";
    phone.text = "9988776655";
    fullAddress.text = "";
    pincode.text = "000000";
    orderId.text = "0";
    amount.text = "0";
    city.text = "";
    state.text = "";
    country.text = "784";
    customvar.text = "testcustomvar";
  }

  onComplete(status, response) {
    var resp = response.toJson();

    try{

      var data = response.data.toString();

      var txtStsMsg = response.data.transactionPaymentStatus ?? "";
      var txtSts = response.data.transactionStatus ?? "";
      Navigator.pop(context);
      if (txtStsMsg == '') {
        txtStsMsg = response.data.transactionPaymentStatus ?? "";
        txtSts = response.data.transactionStatus ?? "";
      }
      if (txtStsMsg == 'Invalid Checksum') {
        // txtStsMsg = "Transaction Canceled";
      }
      var msg = "";
      if(txtStsMsg == 'Success'){
        msg = 'Transaction successful';
      }else {
        msg = 'Transaction '+txtStsMsg;
      }



      AwesomeDialog(
          context: context,
          dialogType: DialogType.SUCCES,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "Airpay",

          /*desc: 'Transaction Status: ' +
            txtSts +
            '\nTransaction Status Message: ' +
            txtStsMsg*/
          desc: msg)
          .show();

    }catch (error) {
      print('Error Exception In onComplete : $error');

    }

  }

  onCardComplete(bool status,CardDetailResponse response) {
    // var resp = response.toJson();
    Navigator.pop(context);


    AwesomeDialog(
        context: context,
        dialogType: DialogType.INFO,
        headerAnimationLoop: true,
        animType: AnimType.BOTTOMSLIDE,
        title: "Airpay",
        desc: 'CARD RESPONSE: \n'+response.toJson().toString())
        .show();
  }

  onQRComplete(bool status, QrDecryptResponse qrDecryptResponse) {
    Navigator.pop(context);

    if(qrDecryptResponse.data !=null){
      merchantId = qrDecryptResponse.data!.merchantId.toString();
      order_id = qrDecryptResponse.data!.orderId.toString();
      amount_value = qrDecryptResponse.data!.amount.toString();
      table_id = qrDecryptResponse.data!.tableId.toString();

      AwesomeDialog(
          context: context,
          dialogType: DialogType.NO_HEADER,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "Airpay",
          btnOkOnPress: () {
            ValidateFields(true);
          },
          btnOkText: 'Proceed to Payments',
          btnOkColor: Colors.blue,

          desc: 'QR Scanned Successfully'+'\n'+'Mid - '+qrDecryptResponse.data!.merchantId.toString()+'\n'+'Order Id - '+qrDecryptResponse.data!.orderId.toString()
              +'\n'+'Table Id - '+qrDecryptResponse.data!.tableId.toString()+'\n'+'Amount - '+qrDecryptResponse.data!.amount.toString()
      )

          .show() ;
    }
    else{
      AwesomeDialog(
          context: context,
          dialogType: DialogType.INFO,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "Airpay",

          desc:'QR Scanned Failed')
          .show() ;
    }

  }

  void ValidateFields(isQR) {
    var msg = '';
    if (fname.text.length < 2) {
      msg = 'Enter first name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(fname.text) == false) {
      msg = 'Enter a valid first name';
    } else if (lname.text.isEmpty) {
      msg = 'Enter last name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(lname.text) == false) {
      msg = 'Enter a valid last name';
    } else if (email.text.isEmpty && phone.text.isEmpty) {
      msg = 'Enter an email ID or phone number';
    } else if (email.text.isNotEmpty &&
        RegExp(r"^[a-zA-Z0-9.a-zA-Z0-9._`{|}~]+@[a-zA-Z0-9]+\.[a-zA-Z]+")
            .hasMatch(email.text) ==
            false) {
      msg = "Please enter a valid email";
    } else if (phone.text.isNotEmpty && phone.text.length < 10) {
      msg = 'Enter a valid phone number';
    }

    if (msg.isNotEmpty) {
      AwesomeDialog(
          context: context,
          dialogType: DialogType.ERROR,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "Airpay",
          btnOkOnPress: () {},
          btnOkColor: Colors.red,
          desc: msg)
          .show();
      return;
    }


    if(isQR == true){
      UserRequest user = UserRequest(
          mercid: merchantId,
          buyerFirstName: fname.text,
          buyerLastName: lname.text,
          buyerEmail: email.text,
          buyerPhone: phone.text,
          buyerAddress: fullAddress.text,
          buyerPinCode: pincode.text,
          orderid: order_id,
          amount: amount_value,
          buyerCity: city.text,
          buyerState: state.text,
          buyerCountry: country.text,
          currency: '784',
          isocurrency: 'AED',
          chmod: '',
          txnsubtype: "",
          wallet: "0",
          isStaging: this.isSandbox,
          actionType: 'IndexPay',
          customvar: customvar.text,
          discount: "35.00",
          isQR: 'Y'
      ); // Please enter discount amount


      Navigator.push(
        context,
        MaterialPageRoute(
          builder: (BuildContext context) => new AirPayUAE(
              user: user,
              closure: (status, response) => {onComplete(status, response)}),
        ),
      );
    }else{
      UserRequest user = UserRequest(
          mercid: '247033',   //247033  247078
          buyerFirstName: fname.text,
          buyerLastName: lname.text,
          buyerEmail: email.text,
          buyerPhone: phone.text,
          buyerAddress: fullAddress.text,
          buyerPinCode: pincode.text,
          orderid: '',
          amount: '100.0',
          buyerCity: city.text,
          buyerState: state.text,
          buyerCountry: country.text,
          currency: '784',
          isocurrency: 'AED',
          chmod: '',
          txnsubtype: '',
          wallet: '0',
          isStaging: this.isSandbox,
          actionType: 'IndexPay',
          customvar: customvar.text,
          discount: '75',
          isQR: 'N'
      );

      Navigator.push(
        context,
        MaterialPageRoute(
          builder: (BuildContext context) => new AirPayUAE(
              user: user,
              closure: (status, response) => {onComplete(status, response)}),
        ),
      );
    }


  }

  /*void ValidateWithoutQRFields(String requestType) {
    var msg = '';
     if (fname.text.length < 2) {
      msg = 'Enter first name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(fname.text) == false) {
      msg = 'Enter a valid first name';
    } else if (lname.text.isEmpty) {
      msg = 'Enter last name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(lname.text) == false) {
      msg = 'Enter a valid last name';
    } else if (email.text.isEmpty && phone.text.isEmpty) {
      msg = 'Enter an email ID or phone number';
    } else if (email.text.isNotEmpty &&
        RegExp(r"^[a-zA-Z0-9.a-zA-Z0-9._`{|}~]+@[a-zA-Z0-9]+\.[a-zA-Z]+")
            .hasMatch(email.text) ==
            false) {
      msg = "Please enter a valid email";
    } else if (phone.text.isNotEmpty && phone.text.length < 10) {
      msg = 'Enter a valid phone number';
    }

    if (msg.isNotEmpty) {
      AwesomeDialog(
          context: context,
          dialogType: DialogType.ERROR,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "Airpay",
          btnOkOnPress: () {},
          btnOkColor: Colors.red,
          desc: msg)
          .show();
      return;
    }


    UserRequest user = UserRequest(
        mercid: '247033',
        buyerFirstName: 'Rajesh',
        buyerLastName: 'Rajesh',
        buyerEmail: 'rajesh@bytize.in',
        buyerPhone: '918122219100',
        buyerAddress: '',
        buyerPinCode: '',
        orderid: '',
        amount: '100.0',
        buyerCity: 'Chennai',
        buyerState: 'Tamilnadu',
        buyerCountry: 'India',
        currency: '784',
        isocurrency: 'AED',
        chmod: '',
        txnsubtype: '',
        wallet: '0',
        isStaging: true,
        actionType: 'IndexPay',
        customvar: '',
        discount: '75',
        isQR: 'N'
        );

    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (BuildContext context) => new AirPayUAE(
            user: user,
            closure: (status, response) => {onComplete(status, response)}),
      ),
    );
  }*/

  void ValidateDirectIndexFields(isQR) {
    var msg = '';
    if (fname.text.length < 2) {
      msg = 'Enter first name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(fname.text) == false) {
      msg = 'Enter a valid first name';
    } else if (lname.text.isEmpty) {
      msg = 'Enter last name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(lname.text) == false) {
      msg = 'Enter a valid last name';
    } else if (email.text.isEmpty && phone.text.isEmpty) {
      msg = 'Enter an email ID or phone number';
    } else if (email.text.isNotEmpty &&
        RegExp(r"^[a-zA-Z0-9.a-zA-Z0-9._`{|}~]+@[a-zA-Z0-9]+\.[a-zA-Z]+")
            .hasMatch(email.text) ==
            false) {
      msg = "Please enter a valid email";
    } else if (phone.text.isNotEmpty && phone.text.length < 10) {
      msg = 'Enter a valid phone number';
    }

    if (msg.isNotEmpty) {
      AwesomeDialog(
          context: context,
          dialogType: DialogType.ERROR,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "Airpay",
          btnOkOnPress: () {},
          btnOkColor: Colors.red,
          desc: msg)
          .show();
      return;
    }

    if(isQR == true){
      UserRequest user = UserRequest(
          mercid: merchantId,
          buyerFirstName: fname.text,
          buyerLastName: lname.text,
          buyerEmail: email.text,
          buyerPhone: phone.text,
          buyerAddress: fullAddress.text,
          buyerPinCode: pincode.text,
          orderid: order_id,
          amount: amount_value,
          buyerCity: city.text,
          buyerState: state.text,
          buyerCountry: country.text,
          currency: '784',
          isocurrency: 'AED',
          chmod: 'pg',
          txnsubtype: "",
          wallet: "0",
          isStaging: this.isSandbox,
          channel: 'pg',
          cardCVV: '123', // 756 // Please pass Card CVV value

          token: "39TDOSGfPE1qv2VaMQ3rsp2q6lkPYMVY",//NekJDaoeSGi7eP4dBRfquREbdpTBoBeB" - 247033, //W8RQ6JvSvtWzwWgolytnPuoVoqpcOD0l //Please pass token value which you get in card details API
          carduniquecode: "mFwcPAJjK2KCuS4vKX5rhgDAgKst8k69",//"HBRI6SADJkmpcya001rO2ZzmRgZcVIbd" - 247033,  //Please pass selected card unique code value

        /*  cardNum:"4005550000000001",
          expiryMM: "05",
          expiryYY: "25",*/

          actionType: 'DirectPay',
          customvar: customvar.text,
          discount: "35.00",
          isQR: 'Y'
      ); // please pass the discount amount value

      Navigator.push(
        context,
        MaterialPageRoute(
          builder: (BuildContext context) => new AirPayUAE(
              user: user,
              closure: (status, response) => {onComplete(status, response)}),
        ),
      );
    }else{
      UserRequest user = UserRequest(
          mercid: '247033', //247033  247078
          buyerFirstName: fname.text,
          buyerLastName: lname.text,
          buyerEmail: email.text,
          buyerPhone: phone.text,
          buyerAddress: fullAddress.text,
          buyerPinCode: pincode.text,
          orderid: '',
          amount: '100.00',
          buyerCity: city.text,
          buyerState: state.text,
          buyerCountry: country.text,
          currency: '784',
          isocurrency: 'AED',
          chmod: 'pg',
          txnsubtype: '',
          wallet: "0",
          isStaging: this.isSandbox,
          channel: 'pg',
          cardCVV: '123', // 756 // Please pass Card CVV value

          token: "39TDOSGfPE1qv2VaMQ3rsp2q6lkPYMVY",//"NekJDaoeSGi7eP4dBRfquREbdpTBoBeB" - 247033, // W8RQ6JvSvtWzwWgolytnPuoVoqpcOD0l //Please pass token value which you get in card details API
          carduniquecode: "mFwcPAJjK2KCuS4vKX5rhgDAgKst8k69",//"HBRI6SADJkmpcya001rO2ZzmRgZcVIbd" - 247033,  //Please pass selected card unique code value


        /*  cardNum:"4005550000000001",
          expiryMM: "05",
          expiryYY: "25",*/

          actionType: 'DirectPay',
          customvar: customvar.text,
          discount: "35.00",
          isQR: 'N'
      ); // please pass the discount amount value

      Navigator.push(
        context,
        MaterialPageRoute(
          builder: (BuildContext context) => new AirPayUAE(
              user: user,
              closure: (status, response) => {onComplete(status, response)}),
        ),
      );
    }


  }

  void getCardDetails(isQR){
    if(isQR == true){
      UserRequest user = UserRequest(
          buyerEmail: email.text,
          buyerPhone: phone.text,
          mercid: merchantId,
          orderid: order_id,
          amount: amount_value,
          customvar: customvar.text,
          discount: "35.00",
          actionType: 'FetchCards',
          isStaging: this.isSandbox,
          isQR: 'Y' // 0 - with QR and 1 - without QR
      );


      Navigator.push(
        context,
        MaterialPageRoute(
          builder: (BuildContext context) => new CardDetails(
              user: user,
              cardDetailClosure: (status, response) => {onCardComplete(status,response)}),
        ),
      );
    }else{
      UserRequest user = UserRequest(
          buyerEmail: email.text,
          buyerPhone: phone.text,
          mercid: '247033', //247033  247078
          orderid: '',
          amount: '100.0',
          customvar: customvar.text,
          discount: "35.00",
          actionType: 'FetchCards',
          isStaging: this.isSandbox,
          isQR: 'N' // Y - with QR and N - without QR
      );


      Navigator.push(
        context,
        MaterialPageRoute(
          builder: (BuildContext context) => new CardDetails(
              user: user,
              cardDetailClosure: (status, response) => {onCardComplete(status,response)}),
        ),
      );
    }

  }

  // void getQrDecrypt(String query_request){
  void getQrDecrypt(){
    UserRequest user = UserRequest(
      // Please pass the Scan QR string value for query request param -
      //print("query_request -->"+'$query_request');
        query: '8fe428787437f536|63982e1718395400a0eef17c07cd78e07ef0827c78c5f03a114d866dfe2ab718db6676e7b07c66dd2cbe25b6340f21820a8657d58b060cc3cd6b394655637e4c0c3dd153f3cd8d0ed5626a9b28404d8f6e091d15dde94030f45a0dce1252d15f7b7d253779c91e197f39f7333219b087',  //qr String Staging 247033
        // query: '4ae95205d05834ca|b18977df37d455ae8ef125f35cbba0ecfc888d7688bb56b6e30b93694c79aa3f82d86857c5447356525804a65406b66b12f696c6ad233b2872312bcc2f471a8c72685204b9bbeb08a3539d1c1d7f769a02c86f2998cf3b299cfd2a032aa17a7940a8b4db62d70b27b38d576dc563e3fd',  //qr String 247033
        //query: 'e56f5f68607b5828|45b2bf981b0b2d991ae3e534006ffe7458032ffcd33c14862e9e40ee16b2ea71225844a24f5a7be2a9ad594b2ed2fa6dfed455f7208c5e6e9022c42f1ed95cc5443aade1408e1a1e67b46a2355ba907ab3261934d9101cac55543e180570903d',  //qr String - production 247078
        //query: query_request,  //qr String
        actionType: 'QRDecrypt',
        isStaging: this.isSandbox);


    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (BuildContext context) => new QRDecrypt(
            user: user,
            qrDecryptClosure: (status,response) => {onQRComplete(status,response)}),
      ),
    );
  }

  //QR Scan Code -
  String _scanResult = 'Scan a QR code';
/*
  Future<void> _scanQRCode() async {
    String barcodeScanRes = await FlutterBarcodeScanner.scanBarcode(
        '#ff6666', 'Cancel', true, ScanMode.QR);

    setState(() {
      _scanResult = barcodeScanRes;
      print("_scanResult -->"+_scanResult);
      if (_scanResult != null && _scanResult.isNotEmpty && _scanResult != '-1'){
        getQrDecrypt(_scanResult);
      }
    });
  }*/


  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          centerTitle: true,
          title: Image.asset(
            'assets/airpays.png',
            height: 40,
            color: Colors.white,
            width: 200,
          ),
          backgroundColor: Colors.blue[900],
        ),
        backgroundColor: Colors.grey[400],
        body: SafeArea(
          child: SingleChildScrollView(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.stretch,
              children: [
                Card(
                  margin: EdgeInsets.fromLTRB(8.0, 8, 8.0, 4),
                  color: Colors.white,
                  child: Padding(
                    padding: const EdgeInsets.fromLTRB(12.0, 2.0, 12.0, 15.0),
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.center,
                      crossAxisAlignment: CrossAxisAlignment.stretch,
                      children: [
                        Text(
                          'Personal Information',
                          style: TextStyle(
                              fontSize: 20.0,
                              color: Colors.blue[900],
                              fontWeight: FontWeight.bold),
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                        Row(
                          children: [
                            Expanded(
                                child: Text(
                                  'First Name *',
                                  style: TextStyle(
                                      fontSize: 18.0, color: Colors.blue[900]),
                                )),
                            SizedBox(
                              width: 10.0,
                            ),
                            Expanded(
                              child: Text(
                                'Last Name *',
                                style: TextStyle(
                                    fontSize: 18.0, color: Colors.blue[900]),
                              ),
                            ),
                          ],
                        ),
                        Row(
                          children: [
                            Expanded(
                                child: TextFormField(
                                  inputFormatters: [
                                    // FilteringTextInputFormatter.allow(RegExp(r'^[a-zA-Z0-9]+$')),
                                    new LengthLimitingTextInputFormatter(18),
                                  ],
                                  keyboardType: TextInputType.name,
                                  decoration: InputDecoration(
                                    hintText: 'First Name',
                                    //   contentPadding: EdgeInsets.all(2.0),
                                    hintStyle: TextStyle(
                                        color: Colors.grey, fontSize: 15.0),
                                  ),
                                  controller: fname,
                                )),
                            SizedBox(
                              width: 10.0,
                            ),
                            Expanded(
                              child: TextFormField(
                                inputFormatters: [
                                  // FilteringTextInputFormatter.allow(RegExp(r'^[a-zA-Z0-9]+$')),
                                  new LengthLimitingTextInputFormatter(18),
                                ],
                                keyboardType: TextInputType.name,
                                decoration: InputDecoration(
                                  hintText: 'Last Name',
                                  // contentPadding: EdgeInsets.all(2.0),
                                  hintStyle: TextStyle(
                                      color: Colors.grey, fontSize: 15.0),
                                ),
                                controller: lname,
                              ),
                            ),
                          ],
                        ),
                        SizedBox(
                          height: 8.0,
                        ),
                        Container(
                          child: TextFormField(
                            validator: (value) => EmailValidator.validate(value!)
                                ? null
                                : "Please enter a valid email",
                            keyboardType: TextInputType.emailAddress,
                            decoration: InputDecoration(
                              hintText: 'Email Id',
                              // contentPadding: EdgeInsets.all(2.0),
                              hintStyle:
                              TextStyle(color: Colors.grey, fontSize: 15.0),
                            ),
                            controller: email,
                          ),
                        ),
                        SizedBox(
                          height: 8.0,
                        ),
                        Container(
                          child: TextFormField(
                            keyboardType: TextInputType.number,
                            inputFormatters: <TextInputFormatter>[
                              new LengthLimitingTextInputFormatter(
                                  10), // for mobile
                              FilteringTextInputFormatter.digitsOnly
                            ], // Only numbers can be entered
                            decoration: InputDecoration(
                              hintText: 'Phone',
                              // contentPadding: EdgeInsets.all(2.0),
                              hintStyle:
                              TextStyle(color: Colors.grey, fontSize: 15.0),
                            ),
                            controller: phone,
                          ),
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                        Container(
                          child: TextFormField(
                            keyboardType: TextInputType.number,
                            inputFormatters: <TextInputFormatter>[
                              new LengthLimitingTextInputFormatter(
                                  10), // for mobile
                              FilteringTextInputFormatter.singleLineFormatter
                            ], // Only numbers can be entered
                            decoration: InputDecoration(
                              hintText: 'CustomVar',
                              // contentPadding: EdgeInsets.all(2.0),
                              hintStyle:
                              TextStyle(color: Colors.grey, fontSize: 15.0),
                            ),
                            controller: customvar,
                          ),
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                      ],
                    ),
                  ),
                ),
                Visibility(
                    visible: true,
                    child: Card(
                      margin: EdgeInsets.fromLTRB(8.0, 8, 8.0, 4),
                      color: Colors.white,
                      child: Padding(
                          padding: EdgeInsets.fromLTRB(8.0, 8, 8.0, 4),
                          child: Column(
                            children: [
                              Row(
                                mainAxisAlignment:
                                MainAxisAlignment.spaceBetween,
                                children: [
                                  Text(
                                    'Address',
                                    style: TextStyle(
                                        color: Colors.blue[900],
                                        fontSize: 20.0,
                                        fontWeight: FontWeight.bold),
                                  ),
                                  IconButton(
                                    onPressed: () {
                                      _showAddress();
                                    },
                                    icon: isVisible
                                        ? Icon(Icons.arrow_drop_up)
                                        : Icon(Icons.arrow_drop_down),
                                    color: Colors.black,
                                  )
                                ],
                              ),
                              Visibility(
                                visible: isVisible,
                                child: Column(
                                  mainAxisAlignment: MainAxisAlignment.center,
                                  crossAxisAlignment:
                                  CrossAxisAlignment.stretch,
                                  children: [
                                    Container(
                                      child: TextFormField(
                                        inputFormatters: <TextInputFormatter>[
                                          //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                          new LengthLimitingTextInputFormatter(
                                              254),
                                        ],
                                        keyboardType: TextInputType.text,
                                        decoration: InputDecoration(
                                          hintText: 'Full Address',
                                          // contentPadding: EdgeInsets.all(2.0),
                                          hintStyle: TextStyle(
                                              color: Colors.grey,
                                              fontSize: 15.0),
                                        ),
                                        controller: fullAddress,
                                      ),
                                    ),
                                    SizedBox(
                                      height: 8.0,
                                    ),
                                    Container(
                                      child: TextFormField(
                                        inputFormatters: <TextInputFormatter>[
                                          //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                          new LengthLimitingTextInputFormatter(
                                              18),
                                        ],
                                        keyboardType: TextInputType.text,
                                        decoration: InputDecoration(
                                          hintText: 'City Name',
                                          // contentPadding: EdgeInsets.all(2.0),
                                          hintStyle: TextStyle(
                                              color: Colors.grey,
                                              fontSize: 15.0),
                                        ),
                                        controller: city,
                                      ),
                                    ),
                                    SizedBox(
                                      height: 8.0,
                                    ),
                                    Row(
                                      children: [
                                        Expanded(
                                            child: Text(
                                              'State Name',
                                              style: TextStyle(
                                                  fontSize: 18.0,
                                                  color: Colors.blue[900]),
                                            )),
                                        SizedBox(
                                          width: 8.0,
                                        ),
                                        Expanded(
                                          child: Text(
                                            'Country Name',
                                            style: TextStyle(
                                                fontSize: 18.0,
                                                color: Colors.blue[900]),
                                          ),
                                        ),
                                      ],
                                    ),
                                    Row(
                                      children: [
                                        Expanded(
                                            child: TextFormField(
                                              inputFormatters: <TextInputFormatter>[
                                                //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                                new LengthLimitingTextInputFormatter(
                                                    18),
                                              ],
                                              keyboardType: TextInputType.name,
                                              decoration: InputDecoration(
                                                hintText: 'State',
                                                //   contentPadding: EdgeInsets.all(2.0),
                                                hintStyle: TextStyle(
                                                    color: Colors.grey,
                                                    fontSize: 15.0),
                                              ),
                                              controller: state,
                                            )),
                                        SizedBox(
                                          width: 10.0,
                                        ),
                                        Expanded(
                                          child: TextFormField(
                                            inputFormatters: <
                                                TextInputFormatter>[
                                              //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                              new LengthLimitingTextInputFormatter(
                                                  18),
                                            ],
                                            keyboardType: TextInputType.name,
                                            decoration: InputDecoration(
                                              hintText: 'Country ',
                                              // contentPadding: EdgeInsets.all(2.0),
                                              hintStyle: TextStyle(
                                                  color: Colors.grey,
                                                  fontSize: 15.0),
                                            ),
                                            controller: country,
                                          ),
                                        ),
                                      ],
                                    ),
                                    SizedBox(
                                      height: 8.0,
                                    ),
                                    Container(
                                      child: TextFormField(
                                        inputFormatters: <TextInputFormatter>[
                                          FilteringTextInputFormatter
                                              .digitsOnly,
                                          new LengthLimitingTextInputFormatter(
                                              8),
                                        ],
                                        keyboardType: TextInputType.number,
                                        decoration: InputDecoration(
                                          hintText: 'PinCode',
                                          // contentPadding: EdgeInsets.all(2.0),
                                          hintStyle: TextStyle(
                                              color: Colors.grey,
                                              fontSize: 15.0),
                                        ),
                                        controller: pincode,
                                      ),
                                    ),
                                    SizedBox(
                                      height: 15.0,
                                    ),
                                  ],
                                ),
                              ),
                            ],
                          )),
                    )),

                //QR Scan Code

                /* Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      _scanQRCode();
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'SCAN QR',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),*/

                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      getQrDecrypt();
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'QR DECRYPT',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      //with QR - true and without QR - false
                      getCardDetails(false);
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'GET CARD DETAILS',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      ValidateDirectIndexFields(true);
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'DIRECT PAY',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      ValidateDirectIndexFields(false);
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'DIRECT PAY - WITHOUT QR',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      ValidateFields(true);
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'ADD CARD',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      ValidateFields(false);
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'WITHOUT QR',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      Navigator.pop(context);
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'BACK',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                )
              ],
            ),
          ),
        ));
  }
}
