// To parse this JSON data, do
//
//     final cardDetailResponse = cardDetailResponseFromJson(jsonString);

import 'dart:convert';

CardDetailResponse cardDetailResponseFromJson(String str) => CardDetailResponse.fromJson(json.decode(str));

String cardDetailResponseToJson(CardDetailResponse data) => json.encode(data.toJson());

class CardDetailResponse {
  int? status;
  String? message;
  String? statusdescription;
  List<Result>? result;
  int? cardcount;
  String? token;

  CardDetailResponse({
    this.status,
    this.message,
    this.statusdescription,
    this.result,
    this.cardcount,
    this.token,
  });

  factory CardDetailResponse.fromJson(Map<String, dynamic> json) => CardDetailResponse(
    status: json["status"],
    message: json["message"],
    statusdescription: json["statusdescription"],
    result: json["result"] == null ? [] : List<Result>.from(json["result"]!.map((x) => Result.fromJson(x))),
    cardcount: json["CARDCOUNT"],
    token: json["token"],
  );

  Map<String, dynamic> toJson() => {
    "status": status,
    "message": message,
    "statusdescription": statusdescription,
    "result": result == null ? [] : List<dynamic>.from(result!.map((x) => x.toJson())),
    "CARDCOUNT": cardcount,
    "token": token,
  };
}

class Result {
  String? cardtpye;
  String? cardstart;
  String? cardend;
  String? expiry;
  String? cardholder;
  String? carduniquecode;
  String? defaultCard;
  String? expirymonth;
  String? expiryyear;

  Result({
    this.cardtpye,
    this.cardstart,
    this.cardend,
    this.expiry,
    this.cardholder,
    this.carduniquecode,
    this.defaultCard,
    this.expirymonth,
    this.expiryyear,
  });

  factory Result.fromJson(Map<String, dynamic> json) => Result(
    cardtpye: json["CARDTPYE"],
    cardstart: json["CARDSTART"],
    cardend: json["CARDEND"],
    expiry: json["EXPIRY"],
    cardholder: json["CARDHOLDER"],
    carduniquecode: json["CARDUNIQUECODE"],
    defaultCard: json["DEFAULT_CARD"],
    expirymonth: json["EXPIRYMONTH"],
    expiryyear: json["EXPIRYYEAR"],
  );

  Map<String, dynamic> toJson() => {
    "CARDTPYE": cardtpye,
    "CARDSTART": cardstart,
    "CARDEND": cardend,
    "EXPIRY": expiry,
    "CARDHOLDER": cardholder,
    "CARDUNIQUECODE": carduniquecode,
    "DEFAULT_CARD": defaultCard,
    "EXPIRYMONTH": expirymonth,
    "EXPIRYYEAR": expiryyear,
  };
}
