// To parse this JSON data, do
//
//     final merchantDetailResponse = merchantDetailResponseFromJson(jsonString);

import 'dart:convert';

MerchantDetailResponse merchantDetailResponseFromJson(String str) => MerchantDetailResponse.fromJson(json.decode(str));

String merchantDetailResponseToJson(MerchantDetailResponse data) => json.encode(data.toJson());

class MerchantDetailResponse {
  int? status;
  String? message;
  Data? data;

  MerchantDetailResponse({
    this.status,
    this.message,
    this.data,
  });

  factory MerchantDetailResponse.fromJson(Map<String, dynamic> json) => MerchantDetailResponse(
    status: json["status"],
    message: json["message"],
    data: json["data"] == null ? null : Data.fromJson(json["data"]),
  );

  Map<String, dynamic> toJson() => {
    "status": status,
    "message": message,
    "data": data?.toJson(),
  };
}

class Data {
  String? merchantId;
  String? name;
  String? email;
  String? phone;
  int? airpayMerchantId;
  String? airpayUsername;
  String? airpayPassword;
  String? airpayApikey;
  String? finalAmount;
  String? orderId;
  String? successUrl;
  String? failedUrl;
  String? transactionSessionId;
  String? customvar;
  String? client_id;
  String? client_secret;

  Data({
    this.merchantId,
    this.name,
    this.email,
    this.phone,
    this.airpayMerchantId,
    this.airpayUsername,
    this.airpayPassword,
    this.airpayApikey,
    this.finalAmount,
    this.orderId,
    this.successUrl,
    this.failedUrl,
    this.transactionSessionId,
    this.customvar,
    this.client_id,
    this.client_secret,
  });

  factory Data.fromJson(Map<String, dynamic> json) => Data(
    merchantId: json["merchant_id"],
    name: json["name"],
    email: json["email"],
    phone: json["phone"],
    airpayMerchantId: json["airpay_merchant_id"],
    airpayUsername: json["airpay_username"],
    airpayPassword: json["airpay_password"],
    airpayApikey: json["airpay_apikey"],
    finalAmount: json["final_amount"],
    orderId: json["order_id"],
    successUrl: json["success_url"],
    failedUrl: json["failed_url"],
    transactionSessionId: json["transaction_session_id"],
    customvar: json["customvar"],
    client_id: json["client_id"],
    client_secret: json["client_secret"],
  );

  Map<String, dynamic> toJson() => {
    "merchant_id": merchantId,
    "name": name,
    "email": email,
    "phone": phone,
    "airpay_merchant_id": airpayMerchantId,
    "airpay_username": airpayUsername,
    "airpay_password": airpayPassword,
    "airpay_apikey": airpayApikey,
    "final_amount": finalAmount,
    "order_id": orderId,
    "success_url": successUrl,
    "failed_url": failedUrl,
    "transaction_session_id": transactionSessionId,
    "customvar": customvar,
    "client_id": client_id,
    "client_secret": client_secret,
  };
}
