// To parse this JSON data, do
//
//     final qrDecryptResponse = qrDecryptResponseFromJson(jsonString);

import 'dart:convert';

QrDecryptResponse qrDecryptResponseFromJson(String str) => QrDecryptResponse.fromJson(json.decode(str));

String qrDecryptResponseToJson(QrDecryptResponse data) => json.encode(data.toJson());

class QrDecryptResponse {
  int? status;
  String? message;
  Data? data;

  QrDecryptResponse({
    this.status,
    this.message,
    this.data,
  });

  factory QrDecryptResponse.fromJson(Map<String, dynamic> json) => QrDecryptResponse(
    status: json["status"],
    message: json["message"],
    data: json["data"] == null ? null : Data.fromJson(json["data"]),
  );

  Map<String, dynamic> toJson() => {
    "status": status,
    "message": message,
    "data": data?.toJson(),
  };
}

class Data {
  String? orderId;
  int? amount;
  String? merchantId;
  String? tableId;

  Data({
    this.orderId,
    this.amount,
    this.merchantId,
    this.tableId,
  });

  factory Data.fromJson(Map<String, dynamic> json) => Data(
    orderId: json["order_id"],
    amount: json["amount"],
    merchantId: json["merchant_id"],
    tableId: json["table_id"],
  );

  Map<String, dynamic> toJson() => {
    "order_id": orderId,
    "amount": amount,
    "merchant_id": merchantId,
    "table_id": tableId,
  };
}
