// To parse this JSON data, do
//
//     final TokenResponse = TokenResponseFromJson(jsonString);

import 'dart:convert';

//Git push code -
TokenResponse tokenResponseFromJson(String str) => TokenResponse.fromJson(json.decode(str));

String tokenResponseToJson(TokenResponse data) => json.encode(data.toJson());

class TokenResponse {
  String? statusCode;
  String? responseCode;
  String? status;
  String? message;
  Data? data;

  TokenResponse({
    this.statusCode,
    this.responseCode,
    this.status,
    this.message,
    this.data,
  });

  factory TokenResponse.fromJson(Map<String, dynamic> json) => TokenResponse(
    statusCode: json["status_code"],
    responseCode: json["response_code"],
    status: json["status"],
    message: json["message"],
    data: json["data"] == null ? null : Data.fromJson(json["data"]),
  );

  Map<String, dynamic> toJson() => {
    "status_code": statusCode,
    "response_code": responseCode,
    "status": status,
    "message": message,
    "data": data?.toJson(),
  };
}

class Data {
  String? accessToken;
  int? expiresIn;
  String? tokenType;
  dynamic scope;

  Data({
    this.accessToken,
    this.expiresIn,
    this.tokenType,
    this.scope,
  });

  factory Data.fromJson(Map<String, dynamic> json) => Data(
    accessToken: json["access_token"],
    expiresIn: json["expires_in"],
    tokenType: json["token_type"],
    scope: json["scope"],
  );

  Map<String, dynamic> toJson() => {
    "access_token": accessToken,
    "expires_in": expiresIn,
    "token_type": tokenType,
    "scope": scope,
  };
}
