// To parse this JSON data, do
//
//     final transaction = transactionFromJson(jsonString);

import 'dart:convert';

Transaction transactionFromJson(String str) => Transaction.fromJson(json.decode(str));

String transactionToJson(Transaction data) => json.encode(data.toJson());

class Transaction {
  String? statusCode;
  String? responseCode;
  String? status;
  String? message;
  Data? data;



  Transaction({
    this.statusCode,
    this.responseCode,
    this.status,
    this.message,
    this.data,
  });

    factory Transaction.fromJson(Map<String, dynamic> json) => Transaction(
      statusCode: json["status_code"],
      responseCode: json["response_code"],
      status: json["status"],
      message: json["message"],
      data: json["data"] == null ? null : Data.fromJson(json["data"]) ?? Data(),
    );

  Map<String, dynamic> toJson() => {
    "status_code": statusCode,
    "response_code": responseCode,
    "status": status,
    "message": message,
    "data": data?.toJson(),
  };
}

class Data {
  String? transactionPaymentStatus;
  String? merchantId;
  String? orderid;
  String? apTransactionid;
  String? txnMode;
  String? chmod;
  String? amount;
  String? currencyCode;
  int? transactionStatus;
  String? message;
  String? bankResponseMsg;
  String? customerName;
  String? customerPhone;
  String? customerEmail;
  int? transactionType;
  String? risk;
  String? customVar;
  String? token;
  String? uid;
  String? transactionTime;
  String? surchargeAmount;
  String? cardType;
  String? apSecurehash;

  Data({
    this.transactionPaymentStatus,
    this.merchantId,
    this.orderid,
    this.apTransactionid,
    this.txnMode,
    this.chmod,
    this.amount,
    this.currencyCode,
    this.transactionStatus,
    this.message,
    this.bankResponseMsg,
    this.customerName,
    this.customerPhone,
    this.customerEmail,
    this.transactionType,
    this.risk,
    this.customVar,
    this.token,
    this.uid,
    this.transactionTime,
    this.surchargeAmount,
    this.cardType,
    this.apSecurehash,
  });

  factory Data.fromJson(Map<String, dynamic> json) => Data(
    transactionPaymentStatus: json["transaction_payment_status"],
    merchantId: json["merchant_id"],
    orderid: json["orderid"],
    apTransactionid: json["ap_transactionid"],
    txnMode: json["txn_mode"],
    chmod: json["chmod"],
    amount: json["amount"],
    currencyCode: json["currency_code"],
    transactionStatus: json["transaction_status"],
    message: json["message"],
    bankResponseMsg: json["bank_response_msg"],
    customerName: json["customer_name"],
    customerPhone: json["customer_phone"],
    customerEmail: json["customer_email"],
    transactionType: json["transaction_type"],
    risk: json["risk"],
    customVar: json["custom_var"],
    token: json["token"],
    uid: json["uid"],
    transactionTime: json["transaction_time"],
    surchargeAmount: json["surcharge_amount"],
    cardType: json["card_type"],
    apSecurehash: json["ap_securehash"],
  );

  Map<String, dynamic> toJson() => {
    "transaction_payment_status": transactionPaymentStatus,
    "merchant_id": merchantId,
    "orderid": orderid,
    "ap_transactionid": apTransactionid,
    "txn_mode": txnMode,
    "chmod": chmod,
    "amount": amount,
    "currency_code": currencyCode,
    "transaction_status": transactionStatus,
    "message": message,
    "bank_response_msg": bankResponseMsg,
    "customer_name": customerName,
    "customer_phone": customerPhone,
    "customer_email": customerEmail,
    "transaction_type": transactionType,
    "risk": risk,
    "custom_var": customVar,
    "token": token,
    "uid": uid,
    "transaction_time": transactionTime,
    "surcharge_amount": surchargeAmount,
    "card_type": cardType,
    "ap_securehash": apSecurehash,
  };
}

class CARDDETAILS {
  String? pRIACCNOSTART;
  String? pRIACCNOEND;
  String? cARDISSUER;
  String? cARDTYPE;
  String? cARDCOUNTRY;

  CARDDETAILS(
      {this.pRIACCNOSTART,
        this.pRIACCNOEND,
        this.cARDISSUER,
        this.cARDTYPE,
        this.cARDCOUNTRY});

  CARDDETAILS.fromJson(Map<String, dynamic> json) {
    pRIACCNOSTART = json['PRI_ACC_NO_START'];
    pRIACCNOEND = json['PRI_ACC_NO_END'];
    cARDISSUER = json['CARDISSUER'];
    cARDTYPE = json['CARDTYPE'];
    cARDCOUNTRY = json['CARDCOUNTRY'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['PRI_ACC_NO_START'] = this.pRIACCNOSTART;
    data['PRI_ACC_NO_END'] = this.pRIACCNOEND;
    data['CARDISSUER'] = this.cARDISSUER;
    data['CARDTYPE'] = this.cARDTYPE;
    data['CARDCOUNTRY'] = this.cARDCOUNTRY;
    return data;
  }
}
