
//New TZ Changes

import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'dart:math';
import 'package:airpay_emar_package/model/MerchantDetailResponse.dart';
import 'package:airpay_emar_package/model/QrDecryptResponse.dart';
import 'package:airpay_emar_package/model/TokenResponse.dart';
import 'package:flutter/material.dart';
import 'package:webview_flutter/webview_flutter.dart';
// Import for Android features.
import 'package:webview_flutter_android/webview_flutter_android.dart';
// Import for iOS features.
import 'package:airpay_emar_package/model/TransactionNew.dart';
import 'package:airpay_emar_package/model/UserRequest.dart';
import 'package:dio/dio.dart';
import 'package:flutter/cupertino.dart';
import 'package:crypto/crypto.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';
import 'package:intl/intl.dart';
import 'package:xml2json/xml2json.dart';
import 'package:http/http.dart' as http;
import 'package:encrypt/encrypt.dart' as encrypt;
import 'package:crc32_checksum/crc32_checksum.dart';

import '../model/Transaction.dart';

typedef void Closure(bool val, Transaction response);
typedef void QRDecryptClosure(bool val, QrDecryptResponse response);

//code push before adding new changes of TZ payment page logics
//ignore: must_be_immutable
class AirPayUAE extends StatefulWidget {
  final UserRequest user;
  final Closure? closure;
  final QRDecryptClosure? qrDecryptClosure;

  bool isShowProgress = true;


  AirPayUAE({Key? key, required this.user, this.closure,this.qrDecryptClosure}) : super(key: key);

  @override
  _AirPayUAEState createState() => new _AirPayUAEState();
}

class _AirPayUAEState extends State<AirPayUAE> {
  bool isShowProgress = true;

  // var URL = 'https://google.com.tr';
  String? url = "";
  var postdata = "";
  late final WebViewController _controller;
  num _stackToView = 1;
  String errMsg = "";
  var payURL = '';
  bool isFirst = true;
  bool isProceed = false;

  String airpayMerchantId = "";
  String airpayApikey = "";
  String airpayUsername = "";
  String airpayPassword = "";
  String transaction_session_id = "";
  String successUrl = "";
  String failedUrl = "";
  String orderId = "";
  String clientSecret = "";
  String clientId = "";
  String grant_type = "";

  var secret_key ='b0B1c#dsaf45ADSF5645adf0215';

  String accessToken_value = "";

  var privatekey_request;
  var privatekey_Directrequest;

  void _handleLoad(int index) {
    setState(() {
      _stackToView = index;
    });
  }

  showLoader(value) {
    setState(() {
      isShowProgress = value;
    });
  }


  Future<String> loadData() async {
    var user = widget.user;
    var actionType = widget.user.actionType;

    if (actionType != null && actionType.isNotEmpty && actionType == "IndexPay") {
      //INDEX FLOW

      Map<String, dynamic> jsonParams = {
        "merchant_id": widget.user.mercid.toString(),
        "order_id": widget.user.orderid.toString(),
        "amount": widget.user.amount.toString(),
        "discount": widget.user.discount.toString(),
        "customvar": widget.user.customvar.toString(),
        "isQR": widget.user.isQR.toString(),

      };
      String jsonString = json.encode(jsonParams);
      var merchant_response = await merchantDetailsApi(jsonString);
      if(merchant_response!= null){
        if (merchant_response.status
            .toString()
            .isNotEmpty && merchant_response.status.toString() == "200")
        {
          airpayApikey = merchant_response.data!.airpayApikey.toString();
          airpayMerchantId = merchant_response.data!.airpayMerchantId.toString();
          airpayUsername = merchant_response.data!.airpayUsername.toString();
          airpayPassword = merchant_response.data!.airpayPassword.toString();
          transaction_session_id = merchant_response.data!.transactionSessionId.toString();
          successUrl = merchant_response.data!.successUrl.toString();
          failedUrl = merchant_response.data!.failedUrl.toString();
          orderId = merchant_response.data!.orderId.toString();
          clientSecret = merchant_response.data!.client_secret.toString();
          clientId = merchant_response.data!.client_id.toString();
          grant_type = "client_credentials";

          //Token API Implementation
          Map<String, dynamic> jsonEncData = {
            "merchant_id": widget.user.mercid.toString(),
            "client_id": clientId,
            "client_secret": clientSecret,
            "grant_type": grant_type,
          };
          String jsonEncDataString = json.encode(jsonEncData);

          var date = new DateTime.now();
          var format = DateFormat("yyyy-MM-dd");
          var formattedDate = format.format(date);

          //Token Checksum
          var  allData = utf8.encode('${clientId}${clientSecret}${grant_type}${widget.user.mercid.toString()}${formattedDate}');
          var checksum = sha256.convert(allData);

          var temp = utf8.encode(
              '${merchant_response.data!.airpayApikey
                  .toString()}@${merchant_response.data!.airpayUsername
                  .toString()}:|:${merchant_response.data!.airpayPassword
                  .toString()}');
          privatekey_request = sha256.convert(temp);


          var sTemp = utf8.encode(
              '${merchant_response.data!.airpayUsername
                  .toString()}~:~${merchant_response.data!.airpayPassword
                  .toString()}');
          var key = md5.convert(sTemp);

          var encryptData = encrypt256WithKey(jsonEncDataString,key.toString()).replaceAll("\n","");

          var tokenResponse = await merchantTokenApi(widget.user.mercid.toString(),checksum.toString(),privatekey_request.toString(),encryptData.toString(), key.toString());
          if(tokenResponse!= null){
            if (tokenResponse.statusCode
                .toString()
                .isNotEmpty && tokenResponse.statusCode.toString() == "200" && tokenResponse.data!= null)
            {
              accessToken_value = tokenResponse.data!.accessToken.toString();

            }else{
              userCancel("Service Unavailable - Token Error");
            }

          }else{
            //return to Merchant App
            userCancel("Service Unavailable");
          }

          /* var protocolDomain = getProtoDomain(merchant_response.data!.successUrl
              .toString()); //widget.user.protoDomain
          List<int> bytes = ascii.encode(protocolDomain);
          var encoded = base64.encode(bytes);*/

          if(accessToken_value!= null)
          {
            String productionURL = "https://payments.airpay.ae/pay/v1/?token=${accessToken_value}";  // UAE Kit Url - .ae domain
            String productionFailedURL = "https://payments.airpay.ae/pay/v1/?token=${accessToken_value}";  // UAE Kit Url - .ae domain

            String stagingURL = "https://uae-payments.airpay.ninja/pay/v1/?token=${accessToken_value}"; //Staging URL
            String stagingFailedURL = "https://uae-payments.airpay.ninja/pay/v1/?token=${accessToken_value}"; //Staging URL

            var isGateWay = (user.isStaging != null && user.isStaging == true)
                ? stagingURL
                : productionURL;
            user.failedUrl = (user.isStaging != null && user.isStaging == true)
                ? stagingFailedURL
                : productionFailedURL;

            //mer_dom generation
            var protocolDomain = getProtoDomain(merchant_response.data!.successUrl
                .toString()); //widget.user.protoDomain
            List<int> bytes = ascii.encode(protocolDomain);
            var encoded = base64.encode(bytes);

            Map<String, dynamic> jsonPaymentRequest = {
              "amount": '${merchant_response.data!.finalAmount.toString()}',
              "buyer_address": '${user.buyerAddress}',
              "buyer_city": '${user.buyerCity}',
              "buyer_country": '${user.buyerCountry}',
              "buyer_email": '${user.buyerEmail}',
              "buyer_firstname": '${user.buyerFirstName}',
              "buyer_lastname": '${user.buyerLastName}',
              "buyer_phone": '${user.buyerPhone}',
              "buyer_pincode": '${user.buyerPinCode}',
              "buyer_state": '${user.buyerState}',
              "chmod": '${user.chmod}',
              "currency_code": '${user.currency}',
              "customvar": '${user.customvar}',
              "iso_currency": '${user.isocurrency}',
              "mer_dom":'$encoded',
              "orderid": '${merchant_response.data!.orderId.toString()}',
              "txnsubtype": '${user.txnsubtype}',
            };
            String jsonTxnRequest = json.encode(jsonPaymentRequest);

            var encryptRequestData = encrypt256WithKey(jsonTxnRequest, key.toString());
            // checksum
            // var  request_allData = utf8.encode('${merchant_response.data!.finalAmount.toString()}${user.buyerEmail}${user.buyerFirstName}${user.buyerLastName}${user.buyerPhone}${user.currency}${user.isocurrency}${merchant_response.data!.orderId.toString()}${formattedDate}');
            var  request_allData = utf8.encode('${merchant_response.data!.finalAmount.toString()}${user.buyerAddress}${user.buyerCity}${user.buyerCountry}${user.buyerEmail}${user.buyerFirstName}${user.buyerLastName}${user.buyerPhone}${user.buyerPinCode}${user.buyerState}${user.chmod}${user.currency}${user.customvar}${user.isocurrency}${encoded}${merchant_response.data!.orderId.toString()}${user.txnsubtype}${formattedDate}');
            var request_checksum = sha256.convert(request_allData);


            var url = "<!DOCTYPE html>" +
                "<html>" +
                "<body onload='document.frm1.submit()'>" +
                "<form action='$isGateWay' method='post' name='frm1'>" +
                "  <input type='hidden' name='privatekey' value='$privatekey_request'><br>" +
                "  <input type='hidden' name='merchant_id' value='$airpayMerchantId'><br>" +
                "  <input type='hidden' name='encdata' value='$encryptRequestData'><br>" +
                "  <input type='hidden' name='checksum' value='$request_checksum'><br>" +
                "</form>" +
                "</body>" +
                "</html>";
            return url;
          }else{
            userCancel("Service Unavailable");
          }

        } else {
          //return to Merchant App - Failed Case for Emar API
          userCancel(""+merchant_response.message.toString());

        }
      }else{
        //return to Merchant App
        userCancel("Service Unavailable");
      }

    }else if (actionType != null && actionType.isNotEmpty && actionType == "DirectPay") {

      //DIRECT INDEX FLOW
      Map<String, dynamic> jsonParams = {
        "merchant_id": widget.user.mercid.toString(),
        "order_id": widget.user.orderid.toString(),
        "amount": widget.user.amount.toString(),
        "discount": widget.user.discount.toString(),
        "customvar": widget.user.customvar.toString(),
        "isQR": widget.user.isQR.toString(),

      };
      String jsonString = json.encode(jsonParams);
      var merchant_response =  await merchantDetailsApi(jsonString);

      if(merchant_response!= null){
        if (merchant_response.status
            .toString()
            .isNotEmpty && merchant_response.status.toString() == "200")
        {
          airpayApikey = merchant_response.data!.airpayApikey.toString();
          airpayMerchantId = merchant_response.data!.airpayMerchantId.toString();
          airpayUsername = merchant_response.data!.airpayUsername.toString();
          airpayPassword = merchant_response.data!.airpayPassword.toString();
          transaction_session_id = merchant_response.data!.transactionSessionId.toString();
          successUrl = merchant_response.data!.successUrl.toString();
          failedUrl = merchant_response.data!.failedUrl.toString();
          orderId = merchant_response.data!.orderId.toString();
          clientSecret = merchant_response.data!.client_secret.toString();
          clientId = merchant_response.data!.client_id.toString();
          grant_type = "client_credentials";


          //Token API Implementation
          Map<String, dynamic> jsonEncData = {
            "merchant_id": widget.user.mercid.toString(),
            "client_id": clientId,
            "client_secret": clientSecret,
            "grant_type": grant_type,
          };
          String jsonEncDataString = json.encode(jsonEncData);


          var date = new DateTime.now();
          var format = DateFormat("yyyy-MM-dd");
          var formattedDate = format.format(date);

          //Token Direct Flow Checksum
          var  allData = utf8.encode('${clientId}${clientSecret}${grant_type}${widget.user.mercid.toString()}${formattedDate}');
          var checksum = sha256.convert(allData);

          var temp = utf8.encode(
              '${merchant_response.data!.airpayApikey
                  .toString()}@${merchant_response.data!.airpayUsername
                  .toString()}:|:${merchant_response.data!.airpayPassword
                  .toString()}');
          privatekey_Directrequest = sha256.convert(temp);

          var sTemp = utf8.encode(
              '${merchant_response.data!.airpayUsername
                  .toString()}~:~${merchant_response.data!.airpayPassword
                  .toString()}');
          var directKey = md5.convert(sTemp);

          var encryptDirectData = encrypt256WithKey(jsonEncDataString,directKey.toString()).replaceAll("\n","");


          var tokenResponse = await merchantTokenApi(widget.user.mercid.toString(),checksum.toString(),privatekey_Directrequest.toString(),encryptDirectData.toString(), directKey.toString());
          if(tokenResponse!= null){
            if (tokenResponse.statusCode
                .toString()
                .isNotEmpty && tokenResponse.statusCode.toString() == "200" && tokenResponse.data!= null)
            {
              accessToken_value = tokenResponse.data!.accessToken.toString();

            }else{
              userCancel("Service Unavailable - Token Error");
            }

          }else{
            //return to Merchant App
            userCancel("Service Unavailable");
          }



          /* var protocolDomain = getProtoDomain(merchant_response.data!.successUrl.toString());
          List<int> bytes = ascii.encode(protocolDomain);
          var encoded = base64.encode(bytes);*/

          if(accessToken_value!= null)
          {
            String productionURL = "https://payments.airpay.ae/pay/v1/embedded/?token=${accessToken_value}"; //"https://payments.airpay.co.in/pay/index.php"; // UAE Kit Url - .ae domain
            String productionFailedURL = "https://payments.airpay.ae/pay/v1/embedded/?token=${accessToken_value}"; //"https://payments.airpay.co.in/error.php"; // UAE Kit Url - .ae domain

            String stagingURL = "https://uae-payments.airpay.ninja/pay/v1/embedded/?token=${accessToken_value}"; //"https://payments.airpay.ninja/pay/index.php"; //Staging URL
            String stagingFailedURL = "https://uae-payments.airpay.ninja/v1/embedded/?token=${accessToken_value}"; //"https://payments.airpay.ninja/error.php"; //Staging URL


            var isGateWay = (user.isStaging != null && user.isStaging == true)
                ? stagingURL
                : productionURL;
            user.failedUrl = (user.isStaging != null && user.isStaging == true)
                ? stagingFailedURL
                : productionFailedURL;

            //Need to change - Start
            //mer_dom generation
            var protocolDomain = getProtoDomain(merchant_response.data!.successUrl
                .toString()); //widget.user.protoDomain
            List<int> bytes = ascii.encode(protocolDomain);
            var encoded = base64.encode(bytes);

            Map<String, dynamic> jsonPaymentRequest = {
              "amount": '${merchant_response.data!.finalAmount.toString()}',
              "buyer_address": '${user.buyerAddress}',
              "buyer_city": '${user.buyerCity}',
              "buyer_country": '${user.buyerCountry}',
              "buyer_email": '${user.buyerEmail}',
              "buyer_firstname": '${user.buyerFirstName}',
              "buyer_lastname": '${user.buyerLastName}',
              "buyer_phone": '${user.buyerPhone}',
              "buyer_pincode": '${user.buyerPinCode}',
              "buyer_state": '${user.buyerState}',

              "carduniquecode": '${user.carduniquecode}', //new fields
              "card_cvv": '${user.cardCVV}', //new fields
              /*
              "card_number": '${user.cardNum}', //new fields*/


              "channel": '${user.channel}',


              "chmod": '${user.chmod}',
              "currency_code": '${user.currency}',
              "customvar": '${user.customvar}',

              /*"expiry_mm": '${user.expiryMM}',
              "expiry_yy": '${user.expiryYY}',*/

              "iso_currency": '${user.isocurrency}',
              "mer_dom":'$encoded',
              "orderid": '${merchant_response.data!.orderId.toString()}',

              "token": '${user.token}', //new fields

              "txnsubtype": '${user.txnsubtype}',
            };
            String jsonTxnRequest = json.encode(jsonPaymentRequest);

            var encryptDirectRequestData = encrypt256WithKey(jsonTxnRequest, directKey.toString());
            // checksum
             var  request_DirectIndexallData = utf8.encode('${merchant_response.data!.finalAmount.toString()}${user.buyerAddress}${user.buyerCity}${user.buyerCountry}${user.buyerEmail}${user.buyerFirstName}${user.buyerLastName}${user.buyerPhone}${user.buyerPinCode}${user.buyerState}${user.cardCVV}${user.carduniquecode}${user.channel}${user.chmod}${user.currency}${user.customvar}${user.isocurrency}${encoded}${merchant_response.data!.orderId.toString()}${user.token}${user.txnsubtype}${formattedDate}');
           // var  request_DirectIndexallData = utf8.encode('${merchant_response.data!.finalAmount.toString()}${user.buyerAddress}${user.buyerCity}${user.buyerCountry}${user.buyerEmail}${user.buyerFirstName}${user.buyerLastName}${user.buyerPhone}${user.buyerPinCode}${user.buyerState}${user.cardCVV}${user.cardNum}${user.channel}${user.chmod}${user.currency}${user.customvar}${user.expiryMM}${user.expiryYY}${user.isocurrency}${encoded}${merchant_response.data!.orderId.toString()}${user.txnsubtype}${formattedDate}');
            var request_DirectChecksum = sha256.convert(request_DirectIndexallData);
            //Need to change - End

            var url = "<!DOCTYPE html>" +
                "<html>" +
                "<body onload='document.frm1.submit()'>" +
                "<form action='$isGateWay' method='post' name='frm1'>" +
                "  <input type='hidden' name='privatekey' value='$privatekey_Directrequest'><br>" +
                "  <input type='hidden' name='merchant_id' value='$airpayMerchantId'><br>" +
                "  <input type='hidden' name='encdata' value='$encryptDirectRequestData'><br>" +
                "  <input type='hidden' name='checksum' value='$request_DirectChecksum'><br>" +
                "</form>" +
                "</body>" +
                "</html>";
            return url;

          }else{
            userCancel("Service Unavailable");
          }

        } else {
          //return to Merchant App - Failed Case for Emar API
          userCancel(""+merchant_response.message.toString());
        }
      }else{
        //return to Merchant App
        userCancel("Service Unavailable");
      }
    }else{

      //New code added
      //closure(true,"Invalid Input Parameter Request");
      Transaction transaction = Transaction();
      transaction.message = 'Invalid Input Parameter Request';
      widget.closure!(false, transaction);
    }
    return url?? '';
  }

  @override
  void initState()  {
    super.initState();
    checkConnection();


    WidgetsBinding.instance.addPostFrameCallback((_) {
      callAsync();
    });


  }

  callAsync() async {
    _asyncMethod();
  }



  Future<void> _asyncMethod() async {

    String errMsg = '';
    // ignore: unnecessary_null_comparison
    if (widget.user == null) {
      errMsg = 'Kindly enter your Airpay details to proceed';
    }

    if (errMsg.isNotEmpty) {
      isProceed = false;
      _showAlert(
          context,
          errMsg +
              '\n to proceed with the demo app you must enter the required details to proceed.');
      print(errMsg);
      return;
    }
    //});
    _handleLoad(1);
    this.payURL = Uri.dataFromString(await loadData(),
        mimeType: 'text/html', encoding: Encoding.getByName('utf-8'))
        .toString();

    // if (Platform.isAndroid) WebView.platform = SurfaceAndroidWebView();
    late final PlatformWebViewControllerCreationParams params;
    params = const PlatformWebViewControllerCreationParams();
    final WebViewController controller =
    WebViewController.fromPlatformCreationParams(params);
    controller
      ..setJavaScriptMode(JavaScriptMode.unrestricted)
      ..setBackgroundColor(const Color(0x00000000))
      ..setNavigationDelegate(
        NavigationDelegate(
          onProgress: (int progress) {},
          onPageStarted: (String url) {


            _handleLoad(1);

            setState(() {
              //var succesPath = getProtoDomain(widget.user.successUrl!);
              var succesPath = getProtoDomain(successUrl);
              var webURLPath = getProtoDomain(url);
              if (succesPath.contains("http://") &&
                  webURLPath.contains("https://")) {
                webURLPath = webURLPath.replaceAll("https://", "http://");
              } else if (succesPath.contains("https://") &&
                  webURLPath.contains("http://")) {
                webURLPath = webURLPath.replaceAll("http://", "https://");
              }

              if (succesPath == webURLPath) {
                // isShow = false;
                _handleLoad(1);
                fetchDetails();
              } else if (failedUrl == webURLPath) {
                userCancel('Transaction failed');
              }
            });
          },
          onPageFinished: (String url1) async {


            if (Platform.isAndroid && this.isFirst == true) {
              this.isFirst = false;
              Future.delayed(const Duration(seconds: 6), () {
                _handleLoad(0);
              });
            } else {
              _handleLoad(0);
            }

          },
          onWebResourceError: (WebResourceError error) {
            debugPrint('''
Page resource error:
  code: ${error.errorCode}
  description: ${error.description}
  errorType: ${error.errorType}
  isForMainFrame: ${error.isForMainFrame}
          ''');
          },
          onNavigationRequest: (NavigationRequest request) {
            return NavigationDecision.navigate;
          },
        ),
      )
      ..addJavaScriptChannel(
        'Toaster',
        onMessageReceived: (JavaScriptMessage message) {
          ScaffoldMessenger.of(context).showSnackBar(
            SnackBar(content: Text(message.message)),
          );
        },
      )
      ..loadRequest(Uri.parse(this.payURL));

    // #docregion platform_features
    if (controller.platform is AndroidWebViewController) {
      AndroidWebViewController.enableDebugging(true);
      (controller.platform as AndroidWebViewController)
          .setMediaPlaybackRequiresUserGesture(false);
    }
    // #enddocregion platform_features

    _controller = controller;
    isProceed = true;

    // });
  }


  checkConnection() async {
    try {
      final result = await InternetAddress.lookup('google.com');
      if (result.isNotEmpty && result[0].rawAddress.isNotEmpty) {
        print('connected');

      }

    } on SocketException catch (_) {
      _showAlert(context, 'No Internet');
      print('not connected');

    }
  }

  String getProtoDomain(String sDomain) {
    if (sDomain.isNotEmpty == true) {
      int slashslash = sDomain.indexOf("//") + 2;
      return sDomain.substring(0, sDomain.indexOf("/", slashslash));
    }
    return '';
  }

//a.php api response
  fetchDetails() async {
    var user = widget.user;

    String stagingDataURL = "https://uae-payments.airpay.ninja/sdk/a.php";
    String productionDataURL = "https://payments.airpay.ae/sdk/a.php";
    var isGateWay = (user.isStaging != null && user.isStaging == true)
        ? stagingDataURL
        : productionDataURL;

    // Date Format - dd/MM/yyyy HH:mm:ss
    String urlString = isGateWay;
    var date = new DateTime.now();
    var format = DateFormat("dd/MM/yyyy HH:mm:ss");
    var formattedDate = format.format(date);
    format = DateFormat("yyyy HH:mm:ss");
    var formattedDate2 = format.format(date);

    //Current Date Format - YYYY MM DD
    var current_date = new DateTime.now();
    var current_date_format = DateFormat("yyyy-MM-dd");
    var CurrentFormattedDate = current_date_format.format(current_date);

    var temp = utf8.encode(
        '${airpayApikey}@${airpayUsername}:|:${airpayPassword}');
    var privatekey = sha256.convert(temp);

    //A.PHP Payment Checksum
    var  allPaymentData = utf8.encode('${formattedDate2}${orderId}${"JSON"}${CurrentFormattedDate}');
    var checksumPayment = sha256.convert(allPaymentData);


    //EncData Object
    Map<String, dynamic> jsonEncPaymentData = {
      "datetime": formattedDate2,
      "orderid": orderId,
      "response_type": "JSON",

    };
    String jsonEncPaymentDataString = json.encode(jsonEncPaymentData);

    var sTempPayment = utf8.encode(
        '${airpayUsername
            .toString()}~:~${airpayPassword
            .toString()}');
    var keyPayment = md5.convert(sTempPayment);

    var encryptPaymentData = encrypt256WithKey(jsonEncPaymentDataString,keyPayment.toString()).replaceAll("\n","");

    FormData formData = new FormData.fromMap({
      "privatekey": privatekey.toString(),
      "checksum": checksumPayment.toString(),
      "merchant_id": airpayMerchantId.toString(),
      "encdata":  encryptPaymentData.toString(),

    });

    Dio dio = new Dio();
    dio.options.headers['Accept'] =
    'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8';


    try{

      var response = await dio.post(urlString, data: formData);

      // var stingDAta = response.data.toString();

      // Parse the response body as JSON
      Map<String, dynamic> parsedResponse = jsonDecode(response.data.toString());
      // Access the 'query' property in the parsed response
      String merchant_id = parsedResponse['merchant_id'];
      String enc = parsedResponse['response'];
      var dataResponse = decrypt256WithKey(enc,keyPayment.toString());

      var payment_response = transactionFromJson(
          dataResponse);


      Transaction transaction = Transaction();
      if (payment_response.data != null) {

        //Calling Acknowled API Implementation -

        Map<String, dynamic> jsonResponseParams = {
          "order_id":  payment_response.data?.orderid.toString(),
          "merchant_id": airpayMerchantId,
          "airpay_id": payment_response.data?.apTransactionid.toString(),
          "txn_mode": payment_response.data?.chmod.toString(),
          "final_amount": payment_response.data?.amount.toString(),
          "status": payment_response.data?.transactionPaymentStatus,
          "transaction_session_id": transaction_session_id,
          "statuscode": payment_response.data?.transactionStatus.toString(),
        };
        String jsonResponseString = json.encode(jsonResponseParams);

        AckResponseApi(jsonResponseString, payment_response);

        //SecureHash Logic START -
        var txtStsMsg = payment_response.data?.transactionPaymentStatus.toString();
        var txtSts = payment_response.data?.transactionStatus.toString();
        if (txtStsMsg == '') {
          txtStsMsg = payment_response.data?.transactionPaymentStatus.toString();
          txtSts = payment_response.data?.transactionStatus.toString();
        }
        if (txtStsMsg == 'Invalid Checksum') {
          // txtStsMsg = "Transaction Canceled";
        }

        var transid = payment_response.data?.orderid.toString();
        var apTransactionID = payment_response.data?.apTransactionid.toString();
        var amount = payment_response.data?.amount.toString();
        var transtatus = payment_response.data?.transactionStatus.toString();
        var message =  payment_response.data?.transactionPaymentStatus.toString();

        var chmode =  payment_response.data?.chmod.toString();
        var secureHash =  payment_response.data?.apSecurehash.toString();

        var merchantid = airpayMerchantId; //Please enter Merchant Id
        var username = airpayUsername;   //Please enter Username


// Calculate the CRC32 checksum
        var sParam =
            '${transid}:${apTransactionID}:${amount}:${transtatus}:${message}:${merchantid}:${username}';

        var checkSumResult = Crc32.calculate(sParam);
        //SecureHash Logic END -
        if (payment_response.data?.transactionStatus.toString() != null) {
          if (checkSumResult.toString() == secureHash.toString()) {
            widget.closure!(true, payment_response);
          } else{
            transaction.message = '${payment_response.data?.transactionPaymentStatus.toString()} - Secure Hash mis-matched';
            widget.closure!(false, payment_response);
          }
        }else{
          transaction.message = payment_response.data?.message.toString();
          widget.closure!(false, transaction);
        }

      }else{

        transaction.message = payment_response.message.toString();
        widget.closure!(false, transaction);
      }

    }catch (error) {
      print('Error Exception In A PHP : $error');
      userCancel("An unexpected error has occurred. Please check transaction status in Merchant Portal.");
    }


  }

  userCancel(String withMessage) {
    var trans = Transaction();
    //trans.sTATUS = '500';
    trans.message = withMessage;
    widget.closure!(false, trans);
  }



  // Additional Code changes for QR Decrypt API Implementation - Start


  // Function to make API call
  Future<void> AckResponseApi(ack_request, Transaction transaction) async {
    //final url = 'https://emar.airpay.ninja/node/api/txnResponse';


    String stagingDataURL = 'https://emar.airpay.ninja/node/api/txnResponse';
    String productionDataURL = 'https://api.airpay.ae/node/api/txnResponse';
    String stagingAirpayKey = "AL0013AL1688469524";
    String stagingPartnerKey = "AF0064AF1688469603";
    String productionAirpayKey = "AL0015AL1693490184";
    String productionPartnerKey = "AF0038AF1693490253";

    var isGateWay = (widget.user.isStaging != null && widget.user.isStaging == true)
        ? stagingDataURL
        : productionDataURL;

    String url = isGateWay;

    var airpayKey = (widget.user.isStaging != null && widget.user.isStaging == true)
        ? stagingAirpayKey
        : productionAirpayKey;
    String airpay_Key = airpayKey;

    var partnerKey = (widget.user.isStaging != null && widget.user.isStaging == true)
        ? stagingPartnerKey
        : productionPartnerKey;
    String partner_Key = partnerKey;


    var acknowledgement_request = encryptStr(ack_request);
    var checksum_header = sha256.convert(utf8.encode('${acknowledgement_request.toString()}${secret_key.toString()}'));

    // Define your request headers
    Map<String, String> headers = {
      'AIRPAYKEY': airpay_Key,
      'PARTNERKEY': partner_Key,
      'CHECKSUM': checksum_header.toString(),
      'Content-Type': 'application/x-www-form-urlencoded'

    };

    // Define your request body
    Map<String, dynamic> requestBody = {
      'query': acknowledgement_request,
    };


    // Send POST request to the API
    final response = await http.post(
      Uri.parse(url),
      headers: headers,
      body: requestBody,

    );

    if (response.statusCode == 200) {
      // Request successful, handle the response here

      // Parse the response body as JSON
      Map<String, dynamic> parsedResponse_status = jsonDecode(response.body);

      // Check if the 'status' key is present in the response
      if (parsedResponse_status.containsKey('status')) {
        // Access the 'status' and 'message' properties in the parsed response
        int status = parsedResponse_status['status'];
        String message = parsedResponse_status['message'];


        return;
        // The rest of your code...
      } else  if (parsedResponse_status.containsKey('query')) {
        // Parse the response body as JSON
        Map<String, dynamic> parsedResponse = jsonDecode(response.body);
        // Access the 'query' property in the parsed response
        String query = parsedResponse['query'];
        String decrypt_response = decryptStr(query);

        return;
      }

    } else {
      // Request failed, handle the error here
      print('ACK API call failed');

    }
  }



  // Function to make API call
  Future<MerchantDetailResponse?> merchantDetailsApi(json_request) async {

    try {
      String stagingDataURL = 'https://emar.airpay.ninja/node/api/getMerchantDetails';
      String productionDataURL = 'https://api.airpay.ae/node/api/getMerchantDetails';
      String stagingAirpayKey = "AL0013AL1688469524";
      String stagingPartnerKey = "AF0064AF1688469603";
      String productionAirpayKey = "AL0015AL1693490184";
      String productionPartnerKey = "AF0038AF1693490253";

      var isGateWay = (widget.user.isStaging != null &&
          widget.user.isStaging == true)
          ? stagingDataURL
          : productionDataURL;

      String url = isGateWay;


      var airpayKey = (widget.user.isStaging != null &&
          widget.user.isStaging == true)
          ? stagingAirpayKey
          : productionAirpayKey;
      String airpay_Key = airpayKey;

      var partnerKey = (widget.user.isStaging != null &&
          widget.user.isStaging == true)
          ? stagingPartnerKey
          : productionPartnerKey;
      String partner_Key = partnerKey;


      var merchant_request = encryptStr(json_request);
      var checksum_header = sha256.convert(
          utf8.encode('${merchant_request.toString()}${secret_key.toString()}'));
      // Define your request headers
      Map<String, String> headers = {
        'AIRPAYKEY': airpay_Key,
        'PARTNERKEY': partner_Key,
        'CHECKSUM': checksum_header.toString(),
        'Content-Type': 'application/x-www-form-urlencoded'
      };

      // Define your request body
      Map<String, dynamic> requestBody = {
        'query': merchant_request,
      };


      // Send POST request to the API
      final response = await http.post(
        Uri.parse(url),
        headers: headers,
        body: requestBody,

      );

      if (response.statusCode == 200) {
        // Request successful, handle the response here

        // Parse the response body as JSON
        Map<String, dynamic> parsedResponse_status = jsonDecode(response.body);

        // Check if the 'status' key is present in the response
        if (parsedResponse_status.containsKey('status')) {
          // Access the 'status' and 'message' properties in the parsed response
          int status = parsedResponse_status['status'];
          String message = parsedResponse_status['message'];

          return MerchantDetailResponse(
              status: status, message: message, data: null);
          // The rest of your code...
        } else if (parsedResponse_status.containsKey('query')) {
          // Parse the response body as JSON
          Map<String, dynamic> parsedResponse = jsonDecode(response.body);
          // Access the 'query' property in the parsed response
          String query = parsedResponse['query'];
          String decrypt_response = decryptStr(query);
          var merchant_details_response = merchantDetailResponseFromJson(
              decrypt_response);

          return merchant_details_response;
        }
        else {
          return null;
        }
      } else {
        // Request failed, handle the error here
        print('API call failed');
        return null;
      }
    }catch (error) {
      print('Error EXception : $error');
      userCancel("Service Unavailable");
    }
  }


  // Function to make API call
  Future<TokenResponse?> merchantTokenApi(String mid,String checksum,String privatekey,String encryptData, String key) async {


    String stagingDataURL = 'https://uae-payments.airpay.ninja/pay/v1/api/oauth2/index.php';
    String productionDataURL = 'https://payments.airpay.ae/pay/v1/api/oauth2/index.php';

    var isGateWay = (widget.user.isStaging != null && widget.user.isStaging == true)
        ? stagingDataURL
        : productionDataURL;

    String url = isGateWay;

    // Define your request body
    Map<String, dynamic> requestBody = {
      'merchant_id': mid,
      'checksum': checksum,
      'privatekey': privatekey,
      'encdata': encryptData,
    };

    try {
      // Send POST request to the API
      final response = await http.post(
        Uri.parse(url),
        //headers: headers,
        body: requestBody,

      );

      if (response.statusCode == 200) {
        // Request successful, handle the response here
        // Parse the response body as JSON
        Map<String, dynamic> parsedResponse = jsonDecode(response.body);

        // Check if the 'status' key is present in the response
        if (parsedResponse.containsKey('response')) {
          // Access the 'status' and 'message' properties in the parsed response
          String merchant_id = parsedResponse['merchant_id'];
          String response = parsedResponse['response'];

          String decrypt_response = decrypt256WithKey(response,key);
          var token_response = tokenResponseFromJson(
              decrypt_response);

          return token_response;

          //  return TokenResponse(status: status,message: message,data: null);
          // The rest of your code...
        } else{
          userCancel("Service Unavailable");
          // return null;
        }
      } else {
        // Request failed, handle the error here
        print('API call failed');
        userCancel("Service Unavailable");
        // return null;
      }
    } catch (error) {
      print('Error EXception : $error');
      userCancel("Service Unavailable");
    }

  }

//Decryption code - MS
  String decryptStr(String fullResponse){
    fullResponse.split("|");

    String ivFromResponse = fullResponse.split("|")[0];
    String encryptedResponse = fullResponse.split("|")[1];

    final key = encrypt.Key.fromUtf8("5PbpCqeioHQ3MWj6dJVeluXD");
    final iv = encrypt.IV.fromUtf8(ivFromResponse);

    final encrypter = encrypt.Encrypter(encrypt.AES(key, mode: encrypt.AESMode.cbc)); //, padding: 'PKCS7'


    final encrypted = encrypt.Encrypted.fromBase16(encryptedResponse);
    final decrypted = encrypter.decrypt(encrypted, iv: iv);

    return decrypted;
  }

  //Encryption code - MS
  String encryptStr(String plainText){

    var generatedIV = generate16DigitNumber();
    final key = encrypt.Key.fromUtf8("5PbpCqeioHQ3MWj6dJVeluXD");
    // final iv = encrypt.IV.fromSecureRandom(16);
    final iv = encrypt.IV.fromUtf8(generatedIV);
    final encrypter = encrypt.Encrypter(encrypt.AES(key,mode:encrypt.AESMode.cbc));

    final encrypted = encrypter.encrypt(plainText, iv: iv);
    final decrypted = encrypter.decrypt(encrypted, iv: iv);

    return generatedIV+"|"+encrypted.base16;
  }


  String encrypt256_Str(String plainText, String secretKey){

    // final key = encrypt.Key.fromUtf8("5PbpCqeioHQ3MWj6dJVeluXD");
    var secretkey_md5 = md5.convert(utf8.encode(secretKey));
    final key = encrypt.Key.fromUtf8(secretkey_md5.toString()); //32
    final iv = encrypt.IV.fromSecureRandom(16);
    final encrypter = encrypt.Encrypter(encrypt.AES(key,mode:encrypt.AESMode.cbc));

    final encrypted = encrypter.encrypt(plainText, iv: iv);
    final decrypted = encrypter.decrypt(encrypted, iv: iv);

    // return "$iv|$encrypted.base64";
    var str = base64Encode(utf8.encode(encrypted.base64));
    return "$iv+$str";
  }

  String generate16DigitNumber() {
    Random random = Random();
    String number = '';
    for (int i = 0; i < 16; i++) {
      number += random.nextInt(10).toString();
    }
    return number;
  }

  //Encryption code - Acq
  String encrypt256Str(String plainText, String secretKey){

    var generatedIV = generate16DigitNumber();

    var secretkey_md5 = md5.convert(utf8.encode(secretKey));

    final key = encrypt.Key.fromUtf8(secretkey_md5.toString()); //32
    final iv = encrypt.IV.fromUtf8(generatedIV);
    final encrypter = encrypt.Encrypter(encrypt.AES(key,mode:encrypt.AESMode.cbc));

    final encrypted = encrypter.encrypt(plainText, iv: iv);
    //  final decrypted = encrypter.decrypt(encrypted, iv: iv);

    return generatedIV + encrypted.base64;
  }

  //Decryption code - Acq
  String decrypt256Str(String fullResponse, String secretKey){

    String ivFromResponse = fullResponse.substring(0, 16);
    String encryptedResponse = fullResponse.substring(16);


    var secretkey_md5 = md5.convert(utf8.encode(secretKey));

    final key = encrypt.Key.fromUtf8(secretkey_md5.toString());
    final iv = encrypt.IV.fromUtf8(ivFromResponse);

    final encrypter = encrypt.Encrypter(encrypt.AES(key, mode: encrypt.AESMode.cbc)); //, padding: 'PKCS7'


    final encrypted = encrypt.Encrypted.fromBase64(encryptedResponse);
    final decrypted = encrypter.decrypt(encrypted, iv: iv);

    return decrypted;
  }

  //Encryption Method for Token API
  String encrypt256WithKey(String plainText, String secretKey){

    var generatedIV = generate16DigitNumber();

    final key = encrypt.Key.fromUtf8(secretKey.toString()); //32
    final iv = encrypt.IV.fromUtf8(generatedIV);
    final encrypter = encrypt.Encrypter(encrypt.AES(key,mode:encrypt.AESMode.cbc));

    final encrypted = encrypter.encrypt(plainText, iv: iv);
    //  final decrypted = encrypter.decrypt(encrypted, iv: iv);

    return generatedIV + encrypted.base64;
  }

  //Decryption Method for Token API
  String decrypt256WithKey(String fullResponse, String secretKey){

    String ivFromResponse = fullResponse.substring(0, 16);
    String encryptedResponse = fullResponse.substring(16);

    final key = encrypt.Key.fromUtf8(secretKey.toString());
    final iv = encrypt.IV.fromUtf8(ivFromResponse);

    final encrypter = encrypt.Encrypter(encrypt.AES(key, mode: encrypt.AESMode.cbc)); //, padding: 'PKCS7'


    final encrypted = encrypt.Encrypted.fromBase64(encryptedResponse);
    final decrypted = encrypter.decrypt(encrypted, iv: iv);

    return decrypted;
  }


// Encryption code - END

//Additional Code changes for QR Decrypt API Implementation - End


  _showAlert(context, message) async {
    this.errMsg = message;
    await showDialog<String>(
      context: context,
      barrierDismissible: false,
      builder: (BuildContext context) {
        String title = "Airpay";
        String message1 = message;
        return Platform.isIOS
            ? new CupertinoAlertDialog(
          title: Text(title),
          content: Text(message1),
          actions: <Widget>[
            new Container(
              margin: EdgeInsets.all(8.0),
              child: ElevatedButton(
                // padding: EdgeInsets.all(12.0),
                onPressed: () {
                  Navigator.pop(context);
                },
                // color: Colors.blue[900],
                child: Text(
                  'Okay',
                  style: TextStyle(color: Colors.white, fontSize: 24.0),
                ),
              ),
            )
          ],
        )
            : new AlertDialog(
          title: Text(title),
          content: Container(
              height: 140.0,
              width: 400.0,
              child: ListView.builder(
                  shrinkWrap: true,
                  itemCount: 1,
                  itemBuilder: (BuildContext context, int index) {
                    return new Column(children: <Widget>[
                      Text(message1),
                    ]);
                  })),
          actions: <Widget>[
            new Container(
              margin: EdgeInsets.all(8.0),
              child: ElevatedButton(
                onPressed: () {
                  Navigator.pop(context);
                },
                child: Text(
                  'Okay',
                  style: TextStyle(color: Colors.white, fontSize: 24.0),
                ),
              ),
            )
          ],
        );
      },
    );
  }

  _showConfirmation(context, message) async {
    await showDialog<String>(
      context: context,
      barrierDismissible: false,
      builder: (BuildContext context) {
        String title = "Airpay";
        String message1 = message;
        return Platform.isIOS
            ? new CupertinoAlertDialog(
          title: Text(title),
          content: Text(message1),
          actions: <Widget>[
            new Container(
              margin: EdgeInsets.all(0),
              child: ElevatedButton(
                // padding: EdgeInsets.all(8.0),
                onPressed: () {
                  Navigator.pop(context);
                  userCancel('User canceled');
                },
                // color: Colors.blue[900],
                child: Text(
                  'Yes',
                  style: TextStyle(color: Colors.white, fontSize: 24.0),
                ),
              ),
            ),
            new Container(
              margin: EdgeInsets.all(0),
              child: ElevatedButton(
                // padding: EdgeInsets.all(8.0),
                onPressed: () {
                  Navigator.pop(context);
                },
                // color: Colors.blue[900],
                child: Text(
                  'No',
                  style: TextStyle(color: Colors.white, fontSize: 24.0),
                ),
              ),
            )
          ],
        )
            : new AlertDialog(
          title: Text(title),
          content: Text(message1),
          actions: <Widget>[
            new Container(
              margin: EdgeInsets.all(0),
              child: ElevatedButton(
                // padding: EdgeInsets.all(2.0),
                onPressed: () {
                  Navigator.pop(context);
                  userCancel('User canceled');
                },
                // color: Colors.blue[900],
                child: Text(
                  'Yes',
                  style: TextStyle(color: Colors.white, fontSize: 24.0),
                ),
              ),
            ),
            new Container(
              margin: EdgeInsets.all(0),
              child: ElevatedButton(
                // padding: EdgeInsets.all(2.0),
                onPressed: () {
                  Navigator.pop(context);
                },
                // color: Colors.blue[900],
                child: Text(
                  'No',
                  style: TextStyle(color: Colors.white, fontSize: 24.0),
                ),
              ),
            ),
          ],
        );
      },
    );
  }

  // InAppWebViewController _webViewController;
  @override
  Widget build(BuildContext context) {
    return SafeArea(
        child: Scaffold(
            appBar: AppBar(
              centerTitle: true,
              title: Image.asset(
                'assets/airpayLogo.png',
                height: 40,
                color: Colors.white,
                width: 200,
              ),
              leading: IconButton(
                icon: Icon(Icons.close),
                onPressed: () => {
                  _showConfirmation(
                      context, "Did you want to cancel this transaction ?")
                },
              ),
              backgroundColor: Colors.blue[900],
              actions: <Widget>[],
            ),
            body: (isProceed
                ? IndexedStack(index: _stackToView as int?, children: [
              Column(children: <Widget>[
                Expanded(child: WebViewWidget(controller: _controller)),
              ]),
              Container(
                  child: Center(
                      child: SpinKitCircle(
                        color: Colors.blue[950],
                        size: 50.0,
                      )))
            ])
                : Container(child: Center(child: Text(this.errMsg))))));
  }

}

